/*! $Id: blogartikel.js 81365 2019-11-11 11:05:24Z sseiz $ */

// functions to update comment counters etc. from Disqus Data – these functions are also used by the "blog"-Widget
// NOTE: if disqus ever updates /count.js (which loads and parses count-data.js) and thus possibly changes count-data.js, this might break

var zpUrlParams;
var disqusDisplayCount;
DISQUSWIDGETS = {};
DISQUSWIDGETS.displayCount = function(res) {
	 disqusDisplayCount = res;
};

function zpUpdateDisqusCounters(jqString, cleave, csingular, cplural){		
	//console.log("updateCounters: " + jqString + " / " + cleave + " / " + csingular + " / " + cplural, disqusDisplayCount);
	
	$z(jqString).each(function(){
		var id = $(this).find(".zpblogshowcomments").attr("data-identifier");
		
		var disqusData = new Object();
		if ( typeof disqusDisplayCount !== "undefined" && disqusDisplayCount.hasOwnProperty('counts') && typeof disqusDisplayCount.counts !== "undefined"){
			disqusData = $.grep(disqusDisplayCount.counts, function(e){ return e.id == id; })[0];
		}
		
		var newContent = '';
		var commentCount = 0;
		if ( disqusData ){
			commentCount = parseInt(disqusData.comments);
		}
		//console.log("Comment count for ID " + id + ": " + commentCount + " - disqusData: ", disqusData);
		// update textual content of comments-block - blog.csingular etc. Data-Attributes are set to page.attributes so users can localize
		var articleUrl = $z(jqString + ' .zpblogshowcomments[data-identifier="' + id + '"]').data("url");
		/*
		var articleUrlWithoutHash = document.createElement('a');
		articleUrlWithoutHash.href = articleUrl;
		articleUrlWithoutHash.hash = ""; 
		*/
		
		var counterSpan = '<span class="disqus-comment-count" data-disqus-identifier="' + id + '">' + commentCount + '</span>';
		if ( parseInt(commentCount) < 1 ){
			newContent = '<a href="' + articleUrl + '">' + cleave + '</a>';
		}
		else if ( parseInt(commentCount) === 1 ){
			newContent = '<a href="' + articleUrl + '">' + counterSpan + ' ' +  csingular + '</a>';
		}
		else {
			newContent = '<a href="' + articleUrl + '">' + counterSpan + ' ' + cplural + '</a>';
		}
		
		$z(jqString + ' .zpblogshowcomments[data-identifier="' + id + '"]').html(newContent);
	});
}

function zpGetDisqusCounters(counterArray, shortname, jqString, cleave, csingular, cplural){
	//console.log("Udating disqus counters: " + "http://" + shortname + ".disqus.com/count-data.js?1=" + counterArray.join("&1="));
	if ( !$(jqString).length || !shortname ){
		return;
	}
	$z.ajax({
		type: 'GET',
		cache: false,
		url: "//" + shortname + ".disqus.com/count-data.js?1=" + counterArray.join("&1="),
		timeout: 3000,
		dataType: "script",
		success: function(){
			zpUpdateDisqusCounters(jqString, cleave, csingular, cplural);
		},
		error: function (xhr, status, error) {
			//console.log("Ajax ERROR: " + status + " " + error);
			if (status == "timeout"){
				return;
			}
		}
	}); 
}

function getPathName(href){
	// converts a (relative) href to a site absolute pathname
	var link = document.createElement("a");
	link.href=href;
	var pathname = link.pathname;
	
	return pathname;
}

function zpBlogGetPrevNextLinks( articleptr, blogid, articleid, blogptr){
	$z.ajax({
		type: 'POST',
		url: articleptr + 'assets/php/blog/api.php',
		dataType: "json",
		data: {"m": "getLinks", "bid": blogid, "aid": articleid},
		timeout: 5000,
		success: function (json) {
			//var blogdepth = (blogptr.match(/..\//g) || []).length;
			var blogptr = json.blogptr;
			var blogdepth = (blogptr.match(/..\//g) || []).length;
			var articledepth = (articleptr.match(/..\//g) || []).length;
			var relativedepth = articledepth - blogdepth;
			
			// The relative urls to blog-articles we receive is relative to the blog-overview article.
			// As the prev/next links are relative to the blog-articles, we need to deal with the possibility
			// of different nesting-levels (depth) of individual Blog-Articles and the Blog-Overview by comparing
			// the pathToRoot from both, which this function receives as the articleptr and blogptr parameters.
			if (!String.prototype.repeat) {
				String.prototype.repeat = function(times) {
					// helper method to be able to quickly repeat a string
					return (new Array(times + 1)).join(this);
				};
			}
			if ( relativedepth >= 0){
				// add depth to url based on the depth diference to root from blog-article and blog-overview
				var nextUrl = "../".repeat(relativedepth) + json.nextUrl
				var prevUrl = "../".repeat(relativedepth) + json.prevUrl
			}
			else{
				// subtract depth from url based on the depth diference to root from blog-article and blog-overview
				var nextUrl = json.nextUrl.split("/").slice(Math.abs(relativedepth)).join("/")
				var prevUrl = json.prevUrl.split("/").slice(Math.abs(relativedepth)).join("/")
			}
			//console.log("blogdepth: " + blogdepth + " - articledepth: " + articledepth + " - relativedepth: " + relativedepth + " - New nextUrl: " + nextUrl + " - prevurl: " + prevUrl);
			
			// only show the links if the links we received in JSON aren't empty
			if ( json.prevUrl !== ""){
				$z('.zpblogartikel[data-article-id="' + articleid + '"] .zpblogpaging a.prevp').attr("href", prevUrl);
			}
			else {
				$z('.zpblogartikel[data-article-id="' + articleid + '"] .zpblogpaging a.prevp').hide();
			}
			
			if ( json.nextUrl !== ""){
				$z('.zpblogartikel[data-article-id="' + articleid + '"] .zpblogpaging a.nextp').attr("href", nextUrl);
			}
			else {
				$z('.zpblogartikel[data-article-id="' + articleid + '"] .zpblogpaging a.nextp').hide();
			}
			
			// if there are multiple articles on one page, use the fist articles' prev url for the last article in order to make sure pages are changed
			if ( $z('.zpblogartikel .zpblogpaging').length > 1 ){
				$z('.zpblogartikel .zpblogpaging').last().find('a.prevp').attr('href', $z('.zpblogartikel .zpblogpaging').first().find('a.prevp').attr('href'));
			}
			// only show one article paging per page
			$z('.zpblogartikel .zpblogpaging').hide();
			$z('.zpblogartikel .zpblogpaging').last().show();
			$z('.zpblogartikel .zpblogpaging').last().find("a.prevp,a.nextp").each(function(){
				if ( getPathName($(this).attr("href")) === document.location.pathname  ){
					// hide next/prev links, if the link points to the current page
					//console.log("Hiding next/prev. Pathname: " + getPathName($(this).attr("href")) + " | Doc pathname: " + document.location.pathname);
					$(this).hide();
				}
			});

		},
		error: function (xhr, status, error) {
			//console.log("Ajax Status: " + status + " / Error: " + error + " | xhr: ", xhr);
		}
	});
	
	return;
}

$z(document).ready(function () {
	// store querystings in object on doc ready
	// based on: https://stackoverflow.com/questions/901115/how-can-i-get-query-string-values-in-javascript#2880929
	var match,
	pl     = /\+/g,  // Regex for replacing addition symbol with a space
	search = /([^&=]+)=?([^&]*)/g,
	decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
	query  = window.location.search.substring(1),
	anchor = window.location.hash;
	
	if ( anchor.indexOf("#zpbla") == 0 ){
		$(window).on('load', function(){
			//window.location.hash = "#disqus_thread";
			// smoothly scroll to comments block
			//console.log("Scroll to Comments");
			if ( $z("#disqus_thread").length ){
			$z('html,body').animate({
					scrollTop: $z("#disqus_thread").first().offset().top - parseInt($z("body").css("padding-top"))
			}, 500);
		}
		});
	}

	zpUrlParams = {};
	while (match = search.exec(query)){
		zpUrlParams[decode(match[1])] = decode(match[2]);
	}
    
	// get ids for all articles on page, where commenting is enabled;
	var ca = [];
	var blogPostRoot = ".zpblogartikel";
	var firstBlogPost = $z(blogPostRoot).has(".zpblogshowcomments").first();
	var cleave = firstBlogPost.data("cleave");
	var csingular = firstBlogPost.data("csingular");
	var cplural = firstBlogPost.data("cplural");
	var shortname = firstBlogPost.find('.zpblogshowcomments').data('shortname') || "";
	
	$z(blogPostRoot + " .zpblogshowcomments").each(function(i,e){
		ca.push($z(e).data("identifier") || "");
	});
	// get the discus counters for all articles with an id found in ca
	zpGetDisqusCounters(ca, shortname, blogPostRoot, cleave, csingular, cplural);
	
	

	function loadDisqus(source, shortname, identifier, url) {
		// disqus usuall allows only one comment-box per page/url, so we have to do a little dance here. Hat-Tip: http://mystrd.at/articles/multiple-disqus-threads-on-one-page/
		if ( !shortname ){
			return;
		}
		
		$z('div#disqus_thread').remove();
		
		if (window.DISQUS) {
			//insert a wrapper in HTML after the relevant "show comments" link
			$z('<div id="disqus_thread"></div>').insertAfter(source);

		   //if Disqus exists, call it's reset method with new parameters
		   DISQUS.reset({
			  reload: true,
			  config: function () {
			  this.page.url = url;
			  this.page.identifier = identifier;
			  }
		   });

		}
	};
	
	$z('.zpblogartikel .zpblogshowcomments').click(function(e){
		e.preventDefault();
		$z('.zpblogshowcomments').removeClass('commentsshown').show();
		//DISQUSWIDGETS.getCount({reset: true});
		
		var shortname = $z(this).attr("data-shortname");
		var identifier = $z(this).attr("data-identifier");
		var url = $z(this).attr("data-url");
		
		//console.log("Load Disqus: " + shortname + " / " +  identifier + " / " + url);
		loadDisqus(this, shortname, identifier, url);
		$z(this).addClass('commentsshown').hide();
		// change browser url - use try/catch to avoid scripterrors when loading the page in internal preview 
		// where browser location differs with url from data-attr
		try{
			window.history.pushState(null, null, url);
		}
		catch(err){
			// can't change history – swallow the JS error to not block loading of headers etc. via other JS
		}
		
		// smoothly scroll to comments block
		//console.log("Scroll to Comments");
		if ( $z("#disqus_thread").length ){
			$z('html,body').animate({
					scrollTop: $z("#disqus_thread").first().offset().top - parseInt($z("body").css("padding-top"))
			}, 500);
		}
		
	});
	
	if ( $z('.zpblogshowcomments').length === 1 ){
		$z('.zpblogshowcomments').first().click();
	}
	
	var jq = '.zpblogartikel .zpblogshowcomments';
	var urlArticle = location.hash.match(/\d+/g); // returns all digits (0-9) in hash (e.g.: "#a1710") as a string, which is the article id 
	if ( urlArticle ){
		// if the url contained an anchor, try to load the comments of the article displayed through anchor otherwise we'll load the comments of the first article
		jq = '.zpblogartikel .zpblogshowcomments[data-identifier="' + urlArticle[0] + '"]';
	}
	$z(jq).first().each(function(e,i){		
		var shortname = $z(this).attr("data-shortname");
		var identifier = $z(this).attr("data-identifier");
		var url = $z(this).attr("data-url");
				
		// initialize discuss and load comments for first post with comments enabled
		
		$z('<div id="disqus_thread"></div>').insertAfter(this);
		disqus_config = function () {
			this.page.url = url;  
			this.page.identifier = identifier; 
		};
		
		(function() { // DON'T EDIT BELOW THIS LINE
		var d = document, s = d.createElement('script');
		s.src = '//' + shortname + '.disqus.com/embed.js';
		s.setAttribute('data-timestamp', +new Date());
		(d.head || d.body).appendChild(s);
		})();
		
		$z(this).hide();
	});
});